;
; Copyright 2007,2008 Martin Wendt / enthusi(ONS)
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program. If not, see <http://www.gnu.org/licenses/>.
; 
; Code was converted to 64tass by oziphantom 2/2020
; 128 port by oziphantom
; I've commented and fixed up some of the magic numbers
; but also added some of my own ;) 
; DIRECTORY and CATALOG will not work, however the Directory 
; listing of the RAM Drive doesn't destroy BASIC code already
; When using this the 128 OS must be enabled and the INDFET, INDCMP
; RAM functions must be intact.
; for Assembly based calls code assumes BANK 0 is used, as per normal.

ILOAD = $0330
ISAVE = $0332
LastUsedDrive = $ba			; 128 safe
EndOfProgramVector = $ae	; 128 safe
FNLEN = $b7 ; length of the current filename 128 SAFE
FNADR = $bb ; address of the filename 128 SAFE There is a byte for the bank somewhere
bankl = $fb
bankm = $fc
bankh = $fd
temp = $fe
STAL = $c1 ; IO start address  128safe
RelocVector = $c3 ; if we are relocating the save, this is the new start address 128safe
SecAddress = $b9 ; curr secondary address 128safe
STATUS = $90 ; I/O STATUS 128safe
Verfiy = $93 ; load or verify 128safe
temp1 = $50
temp2 = $51
temp3 = $52
temp_c3 = $53
temp_cmp = $54
VARTAB = $ae ; the end of the program 128
IOBANK = $c6 ; 128 code needs to understand this variable its in SETBANK format (F7EF)
FNBANK = $c7 ; the bank the 128 has the filename stored probably 1
DriveVariable = $02a1
Installer = $1300
Driver = $1400
BASIC_START = $1c01
CODE_START = $1c0d
PRINTLIN = $8e32
KERNALIOERROR = $f685
CustomIOERORR = $f699	
JINDFET = $ff74
JINDSTA = $ff77
JINDCMP = $ff7a
 


 *=BASIC_START
	.word basend
	.word 0
	.null $9e, format("%d", START)
	.byte 0
basend
	.word 0
 *=CODE_START
 START
	ldx #$00 ;in case you load
	stx $dfff ;after heavy use of c64 :)
_installLauncher
	stx $dffe
_src
	lda launch_code
	sta $de00,x ;store small launcher at de00...
	inc _src+1
	bne +
		inc _src+2
+	inx
	bne _src
_installData
	lda #01
	sta $dffe ;dfff still at 0
_bas_4
	lda start_of_data
	sta $de00,x
	inc _bas_4+1
	bne +
		inc _bas_4+2
+	inx
	bne _bas_4
	inc _installData+1
	lda _installData+1
	cmp #$07 ;transfer 7 pages.
	; 7 is good since only now it wont overwrite future
	; data content at reboot of basic-init-code! 
	bne _installData
bas_end
	ldx #$00 ;set back to bank 0
	;so neoramdrive can start right away!
	stx $dfff
	stx $dffe
	dex ; ldx #$ff
bas_end1 
	inx
	lda ini_txt,x
	beq bas_end2
	jsr $ffd2
	bne bas_end1
bas_end2 
	rts
ini_txt .byte $0d
.text "* neoram-drive 128 is now installed in *",$0d
.text "* neoram. use sys 56832 to install in  *",$0d
.text "* c128. uses $1300-$19f6   ozi /n2c[0] *",$0d,$00
;--------------------------------------
launch_code
;this code is the small kicker at de00 that copies the 
;launcher to $c900 and starts it there

.logical $de00
start_of_launcher 
	ldx #(end_of_first_launcher-start_of_launcher)
	;only copy required no of bytes
sol_1
	lda $de00,x ;adjust x to actual extern code-start
sol_2 
	sta Installer
	inx
	beq sol_end
	inc sol_2+1
	jmp sol_1
sol_end
	lda #$00
	sta sol_2+1
	jmp Installer
end_of_first_launcher
.here
launch_code_over
.logical Installer
;----------------------------------
;now comes the actual launcher that will act 
;from $c900 and must be small enough to for 1st page
;i think the drive-code shall start on 2nd page cleanly *g*
second_launch
	ldx #$00
init_0
	lda #$01
	sta $dffe
init_1 
	lda $de00,x
init_2 
	sta Driver
	inx
	bne init_3
;first page fully read of neoram, go to 2nd page
	inc init_0+1
init_3 
	inc init_2+1
	bne init_4
	inc init_2+2
init_4 
	lda init_2+2
	cmp #$d0 ;written till $cfff?
	bne init_0
	jmp Driver ; launch drive code (finally)
	SAREG .byte 0
	SXREG .byte 0
	SYREG .byte 0
	.cerror * > Driver, " too much install code"
.here
.enc "screen"
.text "this is the launchercode.presented to you by enthusi of onslaught."
.text "please report bugs and feature requests."
sys_starter
jumptable .byte $4c,$00,$de
.text "thanks to x1541 for the design of the neoram!"
.text "contact me via mail c64@enthusi.de /2008"
;-----------------------------------------
;here starts the true drive-code but
;beware it starts at 0,8,0 (l,m,h) address 
;check for labels: startpage0..3
;also ramsize
start_of_data
.logical Driver
start_of_code
	lda #$02 ;drive no
	sta DriveVariable
	lda ILOAD
	sta load 
	lda ILOAD+1 
	sta load+1 
	lda #<load_prg
	sta ILOAD
	lda #>load_prg 
	sta ILOAD+1
	lda ISAVE
	sta save 
	lda ISAVE+1
	sta save+1 
	lda #<save_prg
	sta ISAVE
	lda #>save_prg
	sta ISAVE+1 
	lda #$00
	sta $d020 
	tax 
print 
	lda text,x 
	jsr $ffd2 
	beq print_end 
	inx 
	bne print 
print_end 
	rts 
text
	.enc "none"
 	.byte $93, $0d
 	.text "* neoram-drive 128 n2c/onslaught v0.40 *",$0d
 	.text "*   commodore 128 port by oziphantom   *",$0d
 	.byte $0d, $00
save 
	.byte $ea
	.byte $f5
load 
	.byte $a2
	.byte $f4
save_prg 
	ldy LastUsedDrive
	cpy DriveVariable
	beq ramsave
	jmp (save)
ramsave 
	sei 
	jsr seek_end 		; find the next free spot in RAM
	jsr next_byte_RAMCART 		; leave the first 3 bytes free for the link to next
	jsr next_byte_RAMCART 
	jsr next_byte_RAMCART 
	ldy #$00 
name 
	sty SAREG
	;ldy SAREG
	ldx FNBANK
	lda #FNADR
	jsr JINDFET	
	ldy #$00 
	jsr save_next_byte 
	ldy SAREG
	iny 
	cpy FNLEN 
	bne name 
endname 
	lda #$00 
	tay
	jsr save_next_byte
	lda STAL 
	jsr save_next_byte
	lda STAL+1
	jsr save_next_byte 
saveloop 
	lda STAL+1
	cmp EndOfProgramVector+1
	bne noend 
		lda STAL 
		cmp EndOfProgramVector 
		beq endsave 
noend 
	ldx IOBANK
	lda #STAL
	jsr JINDFET	
	jsr save_next_byte
	inc STAL 
	bne saveloop
		inc STAL+1 
		jmp saveloop 
endsave 
	lda #$00 
	jsr save_byte 
	lda bankl 
	sta SAREG
	lda bankm
	sta SXREG 
	lda bankh
	sta SYREG
	jsr next_byte_RAMCART 
	lda #$00 
	jsr save_next_byte
	lda #$00 
	jsr save_byte 
	jsr seek_end 
	lda SAREG
	jsr save_next_byte
	lda SXREG 
	jsr save_next_byte
	lda SYREG 
	jsr save_byte 
	clc
	cli 
	rts 
	
save_next_byte
	jsr save_byte
next_byte_RAMCART 
	inc bankl
	bne set_end
		inc bankm
		bne set_end
			inc bankh
set_end
	rts


seek_end
startpage0 
	lda #$07 
	sta bankm
	lda #$00
	sta bankl
	sta bankh
findloop 
	ldy #$00 
	jsr get_byte 
	sta temp1
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp2
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp3
	lda temp1
	bne not_0
		lda temp2
		bne not_0
			lda temp3
			beq endfound
not_0 
	ldx temp1
	stx bankl
	ldx temp2
	stx bankm
	ldx temp3
	stx bankh
	jmp findloop 

endfound 
	lda bankl
	sec 
	sbc #$02
	sta bankl
	lda bankm
	sbc #$00 
	sta bankm
	lda bankh
	sbc #$00 
	sta bankh
	clc 
	rts

load_prg
	pha 
	lda LastUsedDrive
	cmp DriveVariable 
	beq okload 
		pla 
		jmp (load) 
okload 
	pla 
	sta Verfiy 
	ldy #$00 
	ldx FNBANK
	lda #FNADR
	jsr JINDFET	
	cmp #$5f ;"<-"
	bne spr0
		jmp formatRAMDRIVE
spr0 
	cmp #$5c ;"pound"
	bne spr1 
		jmp scratch 
spr1 
	cmp #$24 ;"$"
	bne spr2 
		jmp directory 
spr2 
	sei 
	jsr search
	lda SecAddress 
	bne absload 
	lda RelocVector 
	sta $ac
	lda RelocVector+1 
	sta $ad
	jsr next_byte_RAMCART 
	jsr next_byte_RAMCART 
	jmp loadloop 
absload 
	jsr get_byte 
	sta $ac
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta $ad
	jsr next_byte_RAMCART 
loadloop 
	lda bankh
	cmp EndOfProgramVector+2
	bne load1
		lda bankm
		cmp EndOfProgramVector+1
		bne load1 
			lda bankl
			cmp EndOfProgramVector 
			beq endload 
load1 
	lda Verfiy 
	bne verifyFunc 
	jsr get_byte 
	jsr $f7bc
verifyed 
	jsr next_byte_RAMCART 
	inc $ac 
	bne + 
		inc $ad 
+	jmp loadloop 
verifyFunc 
	lda #$ac
	sta $02C8
	jsr get_byte 
	ldx IOBANK
	jsr JINDCMP	
	beq verifyed 
	cli 
	lda #$1c 
	jmp CustomIOERORR 
endload 
	ldx STAL 
	ldy STAL+1 
	cli 
	lda #$40  ; EOI
	sta STATUS 
	clc 
	rts 
search 
startpage1
	lda #$07
	sta bankm
	lda #$00
	sta bankl
	sta bankh
nameloop1 
	ldy #$00 
	sty SAREG 
	lda bankl
	sta STAL
	lda bankm
	sta STAL+1
	lda bankh
	sta temp_c3
	jsr get_byte 
	sta temp1
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp2
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp3
	lda temp1
	bne not_0_2
		lda temp2
		bne not_0_2
			lda temp3
			beq notfound
not_0_2
	lda temp1
	sta EndOfProgramVector
	lda temp2
	sta EndOfProgramVector+1
	lda temp3
	sta EndOfProgramVector+2
	jsr next_byte_RAMCART 
nameloop 
	ldy SAREG 
	ldx FNBANK
	lda #FNADR
	jsr JINDFET	
	cmp #$2a 
	beq ast 
		cmp #$3f 
		beq joker 
			ldy #$00 
			pha 
				jsr get_byte 
				beq found 
					sta temp_cmp
			pla 
			cmp temp_cmp
			bne next 
joker 
	ldy SAREG
	cpy FNLEN 
	beq next 
		iny 
		sty SAREG 
		jsr next_byte_RAMCART 
		jmp nameloop 
found 
	pla 
	ldy SAREG
	cpy FNLEN 
	bne next 
foundnull 
	jsr next_byte_RAMCART 
	ldy #$00 
	rts 
notfound
	pla 
	pla 
	jsr set_bank_rom
	cli 
	jmp KERNALIOERROR ;error-msg

next 
	lda EndOfProgramVector
	sta bankl
	lda EndOfProgramVector+1
	sta bankm
	lda EndOfProgramVector+2
	sta bankh
	jmp nameloop1
 
ast 
	ldy #$00 
seek_0 
	jsr next_byte_RAMCART 
	jsr get_byte 
	bne seek_0 
	beq foundnull 
		
directory 
	sei 
	ldx #$ff
cat2 ; print out the header
	inx 
	lda text0,x
	jsr $ffd2
	bne cat2
	jsr set_bank_ram
startpage2 
	lda VARTAB
	sta dir_end._VARTABLo+1
	lda VARTAB+1
	sta dir_end._VARTABHi+1
	lda #$07
	sta EndOfProgramVector+1
	sta bankm
	lda #$00
	sta bankl
	sta bankh
	sta EndOfProgramVector
	sta EndOfProgramVector+2
catloop 
	ldy #$00 
	jsr get_byte 
	sta temp1
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp2
	jsr next_byte_RAMCART 
	jsr get_byte 
	sta temp3
	lda temp1
	bne not_0_3
		lda temp2
		bne not_0_3
			lda temp3
			bne not_0_3
				jmp nopgm
not_0_3
	sec
	lda temp1
	sbc EndOfProgramVector
	sta pal
	lda temp2
	sbc EndOfProgramVector+1
	sta pam
	jsr set_bank_rom
	ldx pam
	cpx #100
	bcs bignum
		lda #$20
		jsr $ffd2
bignum 
	cpx #10
	bcs realbignum
		lda #$20
		jsr $ffd2
realbignum
	inx ; to avoid 0-block size (still in total free!)
	txa
	jsr printdec
	lda #$20
	jsr $ffd2
	lda #$22
	jsr $ffd2
	jsr set_bank_ram
	lda temp1
	sta EndOfProgramVector
	lda temp2
	sta EndOfProgramVector+1
	lda temp3
	sta EndOfProgramVector+2
	ldy #$00 
p_name 
	jsr next_byte_RAMCART 
	jsr get_byte 
	beq endnme 
		pha 
			jsr set_bank_rom
			cli 
		pla 
		jsr $ffd2 
		sei 
		jsr set_bank_ram
		jmp p_name 
endnme 
	lda EndOfProgramVector 
 	sta bankl
 	lda EndOfProgramVector+1
 	sta bankm
 	lda EndOfProgramVector+2
 	sta bankh
 	jsr set_bank_rom
 	cli
 	lda #$22
 	jsr $ffd2
 	lda #$0d
 	jsr $ffd2
 	sei
 	jsr set_bank_ram
 	jmp catloop
nopgm
	jsr set_bank_rom
	cli
	lda #$0d
	jsr $ffd2
	sec
	lda #$ff
	sbc bankm
	tax
ramsize
	lda #$1f;#$07 for 512KB
	sbc bankh
	jsr PRINTLIN ;dec-print
	ldx #$00
bytesfree 
	lda text1,x
	beq dir_end
	jsr $ffd2
	inx
	bne bytesfree 
dir_end 
	clc
_VARTABLo
	ldx #VARTAB
_VARTABHi
	ldy #VARTAB+1	
	lda #$40 ; EOI
	sta STATUS ;st
	rts
text0 
	.byte $0d,$12
	.text "  neoram-drive  "
	.byte $92,$0d,$0d,$00
text1 
	.text " blocks free"
 	.byte $00
pal .byte $00
pam .byte $00
pah .byte $00
pbl .byte $00
pbm .byte $00
pbh .byte $00
s_l .byte $00 ;src
s_m .byte $00
s_h .byte $00
d_l .byte $00 ;dst
d_m .byte $00
d_h .byte $00
l_l .byte $00 ;len
l_m .byte $00
l_h .byte $00
es_l .byte $00
es_m .byte $00
es_h .byte $00
scratch 
	sei 
	dec FNLEN
	inc FNADR
	bne np
	inc FNADR+1
np 
	jsr search
	jsr seek_end
	jsr next_byte_RAMCART
	jsr next_byte_RAMCART
	jsr next_byte_RAMCART
	jsr next_byte_RAMCART

	lda bankl
	sta es_l
	lda bankm
	sta es_m
	lda bankh
	sta es_h

	sec 
	lda EndOfProgramVector
	sta s_l
	sbc STAL
	sta l_l
	lda EndOfProgramVector+1
	sta s_m
	sbc STAL+1
	sta l_m
	lda EndOfProgramVector+2
	sta s_h
	sbc temp_c3
	sta l_h
nichtab 
	lda STAL
	sta d_l
	lda STAL+1
	sta d_m 
	lda temp_c3
	sta d_h
move_new 
	lda s_l
	sta bankl
	lda s_m
	sta bankm
	lda s_h
	sta bankh
	jsr get_byte 
	pha
		jsr next_byte_RAMCART
		lda bankl
		sta s_l
		lda bankm
		sta s_m
		lda bankh
		sta s_h
		lda d_l 
		sta bankl
		lda d_m
		sta bankm
		lda d_h
		sta bankh
	pla
	jsr save_byte 
	jsr next_byte_RAMCART
	lda bankl
	sta d_l
	lda bankm
	sta d_m
	lda bankh
	sta d_h
	lda s_l
	cmp es_l
	bne move_new
	lda s_m
	cmp es_m
	bne move_new
	lda s_m
	cmp es_m
	bne move_new
korrloop 
	ldy #$00 
	lda STAL
	sta bankl
	lda STAL+1
	sta bankm
	lda temp_c3
	sta bankh
korr2 
	jsr get_byte 
	sta pal
	sec
	sbc l_l 
	sta pbl
	php
		jsr save_next_byte
		jsr get_byte 
		sta pam
	plp 
	sbc l_m
	sta pbm
	php
		jsr save_next_byte
		jsr get_byte 
		sta pah
	plp 
	sbc l_h
	sta pbh
	jsr save_byte 
	lda pal
	bne not_yet_end
	lda pam
	bne not_yet_end
	lda pah
	bne not_yet_end
	lda bankl
	sec 
	sbc #$02
	sta bankl
	lda bankm
	sbc #$00 
	sta bankm
	lda bankh
	sbc #$00 
	sta bankh
	lda #$00
	jsr save_next_byte
	jsr save_next_byte
	jsr save_byte
	jmp endmove_new

not_yet_end
	lda pbl
	sta bankl
	lda pbm
	sta bankm
	lda pbh
	sta bankh
	jmp korr2
endmove_new 
	clc 
	ldx VARTAB 
	ldy VARTAB+1
	cli 
	lda #$40  ; EOI
	sta STATUS 
	rts 
formatRAMDRIVE
	sei
	inc $d020
	jsr set_bank_ram
startpage3
	lda #$07
	sta bankm
	lda #$00
	sta bankl
	sta bankh
	jsr save_next_byte
	jsr save_next_byte
	jsr save_next_byte
	jsr save_next_byte
	sta bankl
	sta bankm
	sta bankh
	jsr set_bank_rom
	dec $d020
	cli
	rts

get_byte 
	lda bankm
	sta temp
	and #%00111111
	sta $dffe
	lda bankh
	asl temp
	rol
	asl temp
	rol
	sta $dfff
	ldx bankl
	lda $de00,x
get_x 
	rts
	
save_byte
	stx save_x+1
	sty save_y+1
	sta save_a+1
	tay
	lda bankm
	sta temp
	and #%00111111
	sta $dffe
	lda bankh
	asl temp
	rol
	asl temp
	rol
	sta $dfff
	ldx bankl
	tya
	sta $de00,x
save_x
	ldx #$00
save_y
	ldy #$00
save_a
	lda #$00
	rts
set_bank_ram
	lda #$3e	
	sta $ff00
	rts
set_bank_rom
	lda #0
	sta $ff00 ; basically bank 15
	rts
printdec
	ldx #0 
pdloop
	jsr div10 
	pha 
	inx 
	cpy #0 
	beq pdloop2 
	tya 
	bcs pdloop 
pdloop2 pla 
	ora #$30
	jsr $ffd2 
	dex 
	bne pdloop2 
div10 
	sec 
	ldy #$ff 
divlp 
	iny 
	sbc #10 
	bcs divlp 
	adc #10 
	rts
	.cerror *-start_of_code > $600, "too much code by ", *-start_of_code-$600 
.here
